Index: lemon/hao_orlin.h
===================================================================
--- lemon/hao_orlin.h	(revision 589)
+++ lemon/hao_orlin.h	(revision 550)
@@ -32,6 +32,6 @@
 /// \brief Implementation of the Hao-Orlin algorithm.
 ///
-/// Implementation of the Hao-Orlin algorithm for finding a minimum cut 
-/// in a digraph.
+/// Implementation of the Hao-Orlin algorithm class for testing network
+/// reliability.
 
 namespace lemon {
@@ -39,32 +39,30 @@
   /// \ingroup min_cut
   ///
-  /// \brief Hao-Orlin algorithm for finding a minimum cut in a digraph.
+  /// \brief %Hao-Orlin algorithm to find a minimum cut in directed graphs.
   ///
-  /// This class implements the Hao-Orlin algorithm for finding a minimum
-  /// value cut in a directed graph \f$D=(V,A)\f$. 
-  /// It takes a fixed node \f$ source \in V \f$ and
+  /// Hao-Orlin calculates a minimum cut in a directed graph
+  /// \f$D=(V,A)\f$. It takes a fixed node \f$ source \in V \f$ and
   /// consists of two phases: in the first phase it determines a
   /// minimum cut with \f$ source \f$ on the source-side (i.e. a set
-  /// \f$ X\subsetneq V \f$ with \f$ source \in X \f$ and minimal outgoing
-  /// capacity) and in the second phase it determines a minimum cut
+  /// \f$ X\subsetneq V \f$ with \f$ source \in X \f$ and minimal
+  /// out-degree) and in the second phase it determines a minimum cut
   /// with \f$ source \f$ on the sink-side (i.e. a set
-  /// \f$ X\subsetneq V \f$ with \f$ source \notin X \f$ and minimal outgoing
-  /// capacity). Obviously, the smaller of these two cuts will be a
+  /// \f$ X\subsetneq V \f$ with \f$ source \notin X \f$ and minimal
+  /// out-degree). Obviously, the smaller of these two cuts will be a
   /// minimum cut of \f$ D \f$. The algorithm is a modified
-  /// preflow push-relabel algorithm. Our implementation calculates
+  /// push-relabel preflow algorithm and our implementation calculates
   /// the minimum cut in \f$ O(n^2\sqrt{m}) \f$ time (we use the
   /// highest-label rule), or in \f$O(nm)\f$ for unit capacities. The
-  /// purpose of such algorithm is e.g. testing network reliability.
+  /// purpose of such algorithm is testing network reliability. For an
+  /// undirected graph you can run just the first phase of the
+  /// algorithm or you can use the algorithm of Nagamochi and Ibaraki
+  /// which solves the undirected problem in
+  /// \f$ O(nm + n^2 \log n) \f$ time: it is implemented in the
+  /// NagamochiIbaraki algorithm class.
   ///
-  /// For an undirected graph you can run just the first phase of the
-  /// algorithm or you can use the algorithm of Nagamochi and Ibaraki,
-  /// which solves the undirected problem in \f$ O(nm + n^2 \log n) \f$ 
-  /// time. It is implemented in the NagamochiIbaraki algorithm class.
-  ///
-  /// \tparam GR The type of the digraph the algorithm runs on.
-  /// \tparam CAP The type of the arc map containing the capacities,
-  /// which can be any numreric type. The default map type is
-  /// \ref concepts::Digraph::ArcMap "GR::ArcMap<int>".
-  /// \tparam TOL Tolerance class for handling inexact computations. The
+  /// \param GR The digraph class the algorithm runs on.
+  /// \param CAP An arc map of capacities which can be any numreric type.
+  /// The default type is \ref concepts::Digraph::ArcMap "GR::ArcMap<int>".
+  /// \param TOL Tolerance class for handling inexact computations. The
   /// default tolerance type is \ref Tolerance "Tolerance<CAP::Value>".
 #ifdef DOXYGEN
@@ -76,18 +74,13 @@
 #endif
   class HaoOrlin {
-  public:
-   
-    /// The digraph type of the algorithm
+  private:
+
     typedef GR Digraph;
-    /// The capacity map type of the algorithm
     typedef CAP CapacityMap;
-    /// The tolerance type of the algorithm
     typedef TOL Tolerance;
 
-  private:
-
     typedef typename CapacityMap::Value Value;
 
-    TEMPLATE_DIGRAPH_TYPEDEFS(Digraph);
+    TEMPLATE_GRAPH_TYPEDEFS(Digraph);
 
     const Digraph& _graph;
@@ -169,5 +162,5 @@
 
     void activate(const Node& i) {
-      (*_active)[i] = true;
+      _active->set(i, true);
 
       int bucket = (*_bucket)[i];
@@ -175,19 +168,19 @@
       if ((*_prev)[i] == INVALID || (*_active)[(*_prev)[i]]) return;
       //unlace
-      (*_next)[(*_prev)[i]] = (*_next)[i];
+      _next->set((*_prev)[i], (*_next)[i]);
       if ((*_next)[i] != INVALID) {
-        (*_prev)[(*_next)[i]] = (*_prev)[i];
+        _prev->set((*_next)[i], (*_prev)[i]);
       } else {
         _last[bucket] = (*_prev)[i];
       }
       //lace
-      (*_next)[i] = _first[bucket];
-      (*_prev)[_first[bucket]] = i;
-      (*_prev)[i] = INVALID;
+      _next->set(i, _first[bucket]);
+      _prev->set(_first[bucket], i);
+      _prev->set(i, INVALID);
       _first[bucket] = i;
     }
 
     void deactivate(const Node& i) {
-      (*_active)[i] = false;
+      _active->set(i, false);
       int bucket = (*_bucket)[i];
 
@@ -195,14 +188,14 @@
 
       //unlace
-      (*_prev)[(*_next)[i]] = (*_prev)[i];
+      _prev->set((*_next)[i], (*_prev)[i]);
       if ((*_prev)[i] != INVALID) {
-        (*_next)[(*_prev)[i]] = (*_next)[i];
+        _next->set((*_prev)[i], (*_next)[i]);
       } else {
         _first[bucket] = (*_next)[i];
       }
       //lace
-      (*_prev)[i] = _last[bucket];
-      (*_next)[_last[bucket]] = i;
-      (*_next)[i] = INVALID;
+      _prev->set(i, _last[bucket]);
+      _next->set(_last[bucket], i);
+      _next->set(i, INVALID);
       _last[bucket] = i;
     }
@@ -211,12 +204,12 @@
       (*_bucket)[i] = bucket;
       if (_last[bucket] != INVALID) {
-        (*_prev)[i] = _last[bucket];
-        (*_next)[_last[bucket]] = i;
-        (*_next)[i] = INVALID;
+        _prev->set(i, _last[bucket]);
+        _next->set(_last[bucket], i);
+        _next->set(i, INVALID);
         _last[bucket] = i;
       } else {
-        (*_prev)[i] = INVALID;
+        _prev->set(i, INVALID);
         _first[bucket] = i;
-        (*_next)[i] = INVALID;
+        _next->set(i, INVALID);
         _last[bucket] = i;
       }
@@ -226,10 +219,9 @@
 
       for (NodeIt n(_graph); n != INVALID; ++n) {
-        (*_excess)[n] = 0;
-        (*_source_set)[n] = false;
+        _excess->set(n, 0);
       }
 
       for (ArcIt a(_graph); a != INVALID; ++a) {
-        (*_flow)[a] = 0;
+        _flow->set(a, 0);
       }
 
@@ -241,5 +233,5 @@
         typename Digraph::template NodeMap<bool> reached(_graph, false);
 
-        reached[_source] = true;
+        reached.set(_source, true);
         bool first_set = true;
 
@@ -249,5 +241,5 @@
 
           queue[qlast++] = t;
-          reached[t] = true;
+          reached.set(t, true);
 
           while (qfirst != qlast) {
@@ -266,5 +258,5 @@
               Node u = _graph.source(a);
               if (!reached[u] && _tolerance.positive((*_capacity)[a])) {
-                reached[u] = true;
+                reached.set(u, true);
                 queue[qlast++] = u;
               }
@@ -275,8 +267,8 @@
 
         ++bucket_num;
-        (*_bucket)[_source] = 0;
+        _bucket->set(_source, 0);
         _dormant[0] = true;
       }
-      (*_source_set)[_source] = true;
+      _source_set->set(_source, true);
 
       Node target = _last[_sets.back().back()];
@@ -285,6 +277,6 @@
           if (_tolerance.positive((*_capacity)[a])) {
             Node u = _graph.target(a);
-            (*_flow)[a] = (*_capacity)[a];
-            (*_excess)[u] += (*_capacity)[a];
+            _flow->set(a, (*_capacity)[a]);
+            _excess->set(u, (*_excess)[u] + (*_capacity)[a]);
             if (!(*_active)[u] && u != _source) {
               activate(u);
@@ -327,12 +319,12 @@
               }
               if (!_tolerance.less(rem, excess)) {
-                (*_flow)[a] += excess;
-                (*_excess)[v] += excess;
+                _flow->set(a, (*_flow)[a] + excess);
+                _excess->set(v, (*_excess)[v] + excess);
                 excess = 0;
                 goto no_more_push;
               } else {
                 excess -= rem;
-                (*_excess)[v] += rem;
-                (*_flow)[a] = (*_capacity)[a];
+                _excess->set(v, (*_excess)[v] + rem);
+                _flow->set(a, (*_capacity)[a]);
               }
             } else if (next_bucket > (*_bucket)[v]) {
@@ -351,12 +343,12 @@
               }
               if (!_tolerance.less(rem, excess)) {
-                (*_flow)[a] -= excess;
-                (*_excess)[v] += excess;
+                _flow->set(a, (*_flow)[a] - excess);
+                _excess->set(v, (*_excess)[v] + excess);
                 excess = 0;
                 goto no_more_push;
               } else {
                 excess -= rem;
-                (*_excess)[v] += rem;
-                (*_flow)[a] = 0;
+                _excess->set(v, (*_excess)[v] + rem);
+                _flow->set(a, 0);
               }
             } else if (next_bucket > (*_bucket)[v]) {
@@ -367,5 +359,5 @@
         no_more_push:
 
-          (*_excess)[n] = excess;
+          _excess->set(n, excess);
 
           if (excess != 0) {
@@ -385,5 +377,5 @@
             } else if (next_bucket == _node_num) {
               _first[(*_bucket)[n]] = (*_next)[n];
-              (*_prev)[(*_next)[n]] = INVALID;
+              _prev->set((*_next)[n], INVALID);
 
               std::list<std::list<int> >::iterator new_set =
@@ -391,8 +383,8 @@
 
               new_set->push_front(bucket_num);
-              (*_bucket)[n] = bucket_num;
+              _bucket->set(n, bucket_num);
               _first[bucket_num] = _last[bucket_num] = n;
-              (*_next)[n] = INVALID;
-              (*_prev)[n] = INVALID;
+              _next->set(n, INVALID);
+              _prev->set(n, INVALID);
               _dormant[bucket_num] = true;
               ++bucket_num;
@@ -404,5 +396,5 @@
             } else {
               _first[*_highest] = (*_next)[n];
-              (*_prev)[(*_next)[n]] = INVALID;
+              _prev->set((*_next)[n], INVALID);
 
               while (next_bucket != *_highest) {
@@ -418,8 +410,8 @@
               --_highest;
 
-              (*_bucket)[n] = *_highest;
-              (*_next)[n] = _first[*_highest];
+              _bucket->set(n, *_highest);
+              _next->set(n, _first[*_highest]);
               if (_first[*_highest] != INVALID) {
-                (*_prev)[_first[*_highest]] = n;
+                _prev->set(_first[*_highest], n);
               } else {
                 _last[*_highest] = n;
@@ -443,5 +435,5 @@
           _min_cut = (*_excess)[target];
           for (NodeIt i(_graph); i != INVALID; ++i) {
-            (*_min_cut_map)[i] = true;
+            _min_cut_map->set(i, true);
           }
           for (std::list<int>::iterator it = _sets.back().begin();
@@ -449,5 +441,5 @@
             Node n = _first[*it];
             while (n != INVALID) {
-              (*_min_cut_map)[n] = false;
+              _min_cut_map->set(n, false);
               n = (*_next)[n];
             }
@@ -462,5 +454,5 @@
               new_target = (*_prev)[target];
             } else {
-              (*_prev)[(*_next)[target]] = (*_prev)[target];
+              _prev->set((*_next)[target], (*_prev)[target]);
               new_target = (*_next)[target];
             }
@@ -468,5 +460,5 @@
               _first[(*_bucket)[target]] = (*_next)[target];
             } else {
-              (*_next)[(*_prev)[target]] = (*_next)[target];
+              _next->set((*_prev)[target], (*_next)[target]);
             }
           } else {
@@ -484,7 +476,7 @@
           }
 
-          (*_bucket)[target] = 0;
-
-          (*_source_set)[target] = true;
+          _bucket->set(target, 0);
+
+          _source_set->set(target, true);
           for (OutArcIt a(_graph, target); a != INVALID; ++a) {
             Value rem = (*_capacity)[a] - (*_flow)[a];
@@ -494,6 +486,6 @@
               activate(v);
             }
-            (*_excess)[v] += rem;
-            (*_flow)[a] = (*_capacity)[a];
+            _excess->set(v, (*_excess)[v] + rem);
+            _flow->set(a, (*_capacity)[a]);
           }
 
@@ -505,6 +497,6 @@
               activate(v);
             }
-            (*_excess)[v] += rem;
-            (*_flow)[a] = 0;
+            _excess->set(v, (*_excess)[v] + rem);
+            _flow->set(a, 0);
           }
 
@@ -526,10 +518,9 @@
 
       for (NodeIt n(_graph); n != INVALID; ++n) {
-        (*_excess)[n] = 0;
-        (*_source_set)[n] = false;
+        _excess->set(n, 0);
       }
 
       for (ArcIt a(_graph); a != INVALID; ++a) {
-        (*_flow)[a] = 0;
+        _flow->set(a, 0);
       }
 
@@ -541,5 +532,5 @@
         typename Digraph::template NodeMap<bool> reached(_graph, false);
 
-        reached[_source] = true;
+        reached.set(_source, true);
 
         bool first_set = true;
@@ -550,5 +541,5 @@
 
           queue[qlast++] = t;
-          reached[t] = true;
+          reached.set(t, true);
 
           while (qfirst != qlast) {
@@ -567,5 +558,5 @@
               Node u = _graph.target(a);
               if (!reached[u] && _tolerance.positive((*_capacity)[a])) {
-                reached[u] = true;
+                reached.set(u, true);
                 queue[qlast++] = u;
               }
@@ -576,8 +567,8 @@
 
         ++bucket_num;
-        (*_bucket)[_source] = 0;
+        _bucket->set(_source, 0);
         _dormant[0] = true;
       }
-      (*_source_set)[_source] = true;
+      _source_set->set(_source, true);
 
       Node target = _last[_sets.back().back()];
@@ -586,6 +577,6 @@
           if (_tolerance.positive((*_capacity)[a])) {
             Node u = _graph.source(a);
-            (*_flow)[a] = (*_capacity)[a];
-            (*_excess)[u] += (*_capacity)[a];
+            _flow->set(a, (*_capacity)[a]);
+            _excess->set(u, (*_excess)[u] + (*_capacity)[a]);
             if (!(*_active)[u] && u != _source) {
               activate(u);
@@ -628,12 +619,12 @@
               }
               if (!_tolerance.less(rem, excess)) {
-                (*_flow)[a] += excess;
-                (*_excess)[v] += excess;
+                _flow->set(a, (*_flow)[a] + excess);
+                _excess->set(v, (*_excess)[v] + excess);
                 excess = 0;
                 goto no_more_push;
               } else {
                 excess -= rem;
-                (*_excess)[v] += rem;
-                (*_flow)[a] = (*_capacity)[a];
+                _excess->set(v, (*_excess)[v] + rem);
+                _flow->set(a, (*_capacity)[a]);
               }
             } else if (next_bucket > (*_bucket)[v]) {
@@ -652,12 +643,12 @@
               }
               if (!_tolerance.less(rem, excess)) {
-                (*_flow)[a] -= excess;
-                (*_excess)[v] += excess;
+                _flow->set(a, (*_flow)[a] - excess);
+                _excess->set(v, (*_excess)[v] + excess);
                 excess = 0;
                 goto no_more_push;
               } else {
                 excess -= rem;
-                (*_excess)[v] += rem;
-                (*_flow)[a] = 0;
+                _excess->set(v, (*_excess)[v] + rem);
+                _flow->set(a, 0);
               }
             } else if (next_bucket > (*_bucket)[v]) {
@@ -668,5 +659,5 @@
         no_more_push:
 
-          (*_excess)[n] = excess;
+          _excess->set(n, excess);
 
           if (excess != 0) {
@@ -686,5 +677,5 @@
             } else if (next_bucket == _node_num) {
               _first[(*_bucket)[n]] = (*_next)[n];
-              (*_prev)[(*_next)[n]] = INVALID;
+              _prev->set((*_next)[n], INVALID);
 
               std::list<std::list<int> >::iterator new_set =
@@ -692,8 +683,8 @@
 
               new_set->push_front(bucket_num);
-              (*_bucket)[n] = bucket_num;
+              _bucket->set(n, bucket_num);
               _first[bucket_num] = _last[bucket_num] = n;
-              (*_next)[n] = INVALID;
-              (*_prev)[n] = INVALID;
+              _next->set(n, INVALID);
+              _prev->set(n, INVALID);
               _dormant[bucket_num] = true;
               ++bucket_num;
@@ -705,5 +696,5 @@
             } else {
               _first[*_highest] = (*_next)[n];
-              (*_prev)[(*_next)[n]] = INVALID;
+              _prev->set((*_next)[n], INVALID);
 
               while (next_bucket != *_highest) {
@@ -718,8 +709,8 @@
               --_highest;
 
-              (*_bucket)[n] = *_highest;
-              (*_next)[n] = _first[*_highest];
+              _bucket->set(n, *_highest);
+              _next->set(n, _first[*_highest]);
               if (_first[*_highest] != INVALID) {
-                (*_prev)[_first[*_highest]] = n;
+                _prev->set(_first[*_highest], n);
               } else {
                 _last[*_highest] = n;
@@ -743,5 +734,5 @@
           _min_cut = (*_excess)[target];
           for (NodeIt i(_graph); i != INVALID; ++i) {
-            (*_min_cut_map)[i] = false;
+            _min_cut_map->set(i, false);
           }
           for (std::list<int>::iterator it = _sets.back().begin();
@@ -749,5 +740,5 @@
             Node n = _first[*it];
             while (n != INVALID) {
-              (*_min_cut_map)[n] = true;
+              _min_cut_map->set(n, true);
               n = (*_next)[n];
             }
@@ -762,5 +753,5 @@
               new_target = (*_prev)[target];
             } else {
-              (*_prev)[(*_next)[target]] = (*_prev)[target];
+              _prev->set((*_next)[target], (*_prev)[target]);
               new_target = (*_next)[target];
             }
@@ -768,5 +759,5 @@
               _first[(*_bucket)[target]] = (*_next)[target];
             } else {
-              (*_next)[(*_prev)[target]] = (*_next)[target];
+              _next->set((*_prev)[target], (*_next)[target]);
             }
           } else {
@@ -784,7 +775,7 @@
           }
 
-          (*_bucket)[target] = 0;
-
-          (*_source_set)[target] = true;
+          _bucket->set(target, 0);
+
+          _source_set->set(target, true);
           for (InArcIt a(_graph, target); a != INVALID; ++a) {
             Value rem = (*_capacity)[a] - (*_flow)[a];
@@ -794,6 +785,6 @@
               activate(v);
             }
-            (*_excess)[v] += rem;
-            (*_flow)[a] = (*_capacity)[a];
+            _excess->set(v, (*_excess)[v] + rem);
+            _flow->set(a, (*_capacity)[a]);
           }
 
@@ -805,6 +796,6 @@
               activate(v);
             }
-            (*_excess)[v] += rem;
-            (*_flow)[a] = 0;
+            _excess->set(v, (*_excess)[v] + rem);
+            _flow->set(a, 0);
           }
 
@@ -825,30 +816,29 @@
   public:
 
-    /// \name Execution Control
+    /// \name Execution control
     /// The simplest way to execute the algorithm is to use
     /// one of the member functions called \ref run().
     /// \n
-    /// If you need better control on the execution,
-    /// you have to call one of the \ref init() functions first, then
-    /// \ref calculateOut() and/or \ref calculateIn().
+    /// If you need more control on the execution,
+    /// first you must call \ref init(), then the \ref calculateIn() or
+    /// \ref calculateOut() functions.
 
     /// @{
 
-    /// \brief Initialize the internal data structures.
+    /// \brief Initializes the internal data structures.
     ///
-    /// This function initializes the internal data structures. It creates
-    /// the maps and some bucket structures for the algorithm.
-    /// The first node is used as the source node for the push-relabel
-    /// algorithm.
+    /// Initializes the internal data structures. It creates
+    /// the maps, residual graph adaptors and some bucket structures
+    /// for the algorithm.
     void init() {
       init(NodeIt(_graph));
     }
 
-    /// \brief Initialize the internal data structures.
+    /// \brief Initializes the internal data structures.
     ///
-    /// This function initializes the internal data structures. It creates
-    /// the maps and some bucket structures for the algorithm. 
-    /// The given node is used as the source node for the push-relabel
-    /// algorithm.
+    /// Initializes the internal data structures. It creates
+    /// the maps, residual graph adaptor and some bucket structures
+    /// for the algorithm. Node \c source  is used as the push-relabel
+    /// algorithm's source.
     void init(const Node& source) {
       _source = source;
@@ -890,24 +880,20 @@
 
 
-    /// \brief Calculate a minimum cut with \f$ source \f$ on the
+    /// \brief Calculates a minimum cut with \f$ source \f$ on the
     /// source-side.
     ///
-    /// This function calculates a minimum cut with \f$ source \f$ on the
+    /// Calculates a minimum cut with \f$ source \f$ on the
     /// source-side (i.e. a set \f$ X\subsetneq V \f$ with
-    /// \f$ source \in X \f$ and minimal outgoing capacity).
-    ///
-    /// \pre \ref init() must be called before using this function.
+    /// \f$ source \in X \f$ and minimal out-degree).
     void calculateOut() {
       findMinCutOut();
     }
 
-    /// \brief Calculate a minimum cut with \f$ source \f$ on the
-    /// sink-side.
+    /// \brief Calculates a minimum cut with \f$ source \f$ on the
+    /// target-side.
     ///
-    /// This function calculates a minimum cut with \f$ source \f$ on the
-    /// sink-side (i.e. a set \f$ X\subsetneq V \f$ with
-    /// \f$ source \notin X \f$ and minimal outgoing capacity).
-    ///
-    /// \pre \ref init() must be called before using this function.
+    /// Calculates a minimum cut with \f$ source \f$ on the
+    /// target-side (i.e. a set \f$ X\subsetneq V \f$ with
+    /// \f$ source \in X \f$ and minimal out-degree).
     void calculateIn() {
       findMinCutIn();
@@ -915,8 +901,8 @@
 
 
-    /// \brief Run the algorithm.
+    /// \brief Runs the algorithm.
     ///
-    /// This function runs the algorithm. It finds nodes \c source and
-    /// \c target arbitrarily and then calls \ref init(), \ref calculateOut()
+    /// Runs the algorithm. It finds nodes \c source and \c target
+    /// arbitrarily and then calls \ref init(), \ref calculateOut()
     /// and \ref calculateIn().
     void run() {
@@ -926,9 +912,9 @@
     }
 
-    /// \brief Run the algorithm.
+    /// \brief Runs the algorithm.
     ///
-    /// This function runs the algorithm. It uses the given \c source node, 
-    /// finds a proper \c target node and then calls the \ref init(),
-    /// \ref calculateOut() and \ref calculateIn().
+    /// Runs the algorithm. It uses the given \c source node, finds a
+    /// proper \c target and then calls the \ref init(), \ref
+    /// calculateOut() and \ref calculateIn().
     void run(const Node& s) {
       init(s);
@@ -941,16 +927,14 @@
     /// \name Query Functions
     /// The result of the %HaoOrlin algorithm
-    /// can be obtained using these functions.\n
-    /// \ref run(), \ref calculateOut() or \ref calculateIn() 
-    /// should be called before using them.
+    /// can be obtained using these functions.
+    /// \n
+    /// Before using these functions, either \ref run(), \ref
+    /// calculateOut() or \ref calculateIn() must be called.
 
     /// @{
 
-    /// \brief Return the value of the minimum cut.
+    /// \brief Returns the value of the minimum value cut.
     ///
-    /// This function returns the value of the minimum cut.
-    ///
-    /// \pre \ref run(), \ref calculateOut() or \ref calculateIn() 
-    /// must be called before using this function.
+    /// Returns the value of the minimum value cut.
     Value minCutValue() const {
       return _min_cut;
@@ -958,22 +942,15 @@
 
 
-    /// \brief Return a minimum cut.
+    /// \brief Returns a minimum cut.
     ///
-    /// This function sets \c cutMap to the characteristic vector of a
-    /// minimum value cut: it will give a non-empty set \f$ X\subsetneq V \f$
-    /// with minimal outgoing capacity (i.e. \c cutMap will be \c true exactly
-    /// for the nodes of \f$ X \f$).
-    ///
-    /// \param cutMap A \ref concepts::WriteMap "writable" node map with
-    /// \c bool (or convertible) value type.
-    ///
-    /// \return The value of the minimum cut.
-    ///
-    /// \pre \ref run(), \ref calculateOut() or \ref calculateIn() 
-    /// must be called before using this function.
-    template <typename CutMap>
-    Value minCutMap(CutMap& cutMap) const {
+    /// Sets \c nodeMap to the characteristic vector of a minimum
+    /// value cut: it will give a nonempty set \f$ X\subsetneq V \f$
+    /// with minimal out-degree (i.e. \c nodeMap will be true exactly
+    /// for the nodes of \f$ X \f$).  \pre nodeMap should be a
+    /// bool-valued node-map.
+    template <typename NodeMap>
+    Value minCutMap(NodeMap& nodeMap) const {
       for (NodeIt it(_graph); it != INVALID; ++it) {
-        cutMap.set(it, (*_min_cut_map)[it]);
+        nodeMap.set(it, (*_min_cut_map)[it]);
       }
       return _min_cut;
@@ -984,4 +961,5 @@
   }; //class HaoOrlin
 
+
 } //namespace lemon
 
Index: lemon/hypercube_graph.h
===================================================================
--- lemon/hypercube_graph.h	(revision 574)
+++ lemon/hypercube_graph.h	(revision 550)
@@ -293,5 +293,7 @@
   ///
   /// This graph type fully conforms to the \ref concepts::Graph
-  /// "Graph concept".
+  /// "Graph" concept, and it also has an important extra feature
+  /// that its maps are real \ref concepts::ReferenceMap
+  /// "reference map"s.
   class HypercubeGraph : public ExtendedHypercubeGraphBase {
   public:
Index: lemon/kruskal.h
===================================================================
--- lemon/kruskal.h	(revision 576)
+++ lemon/kruskal.h	(revision 440)
@@ -249,9 +249,9 @@
   /// \ingroup spantree
   ///
-  /// \brief Kruskal's algorithm for finding a minimum cost spanning tree of
+  /// \brief Kruskal algorithm to find a minimum cost spanning tree of
   /// a graph.
   ///
   /// This function runs Kruskal's algorithm to find a minimum cost
-  /// spanning tree of a graph.
+  /// spanning tree.
   /// Due to some C++ hacking, it accepts various input and output types.
   ///
@@ -265,7 +265,7 @@
   /// It can be one of the following choices.
   /// - An STL compatible 'Forward Container' with
-  /// <tt>std::pair<GR::Arc,C></tt> or
-  /// <tt>std::pair<GR::Edge,C></tt> as its <tt>value_type</tt>, where
-  /// \c C is the type of the costs. The pairs indicates the arcs/edges
+  /// <tt>std::pair<GR::Arc,X></tt> or
+  /// <tt>std::pair<GR::Edge,X></tt> as its <tt>value_type</tt>, where
+  /// \c X is the type of the costs. The pairs indicates the arcs/edges
   /// along with the assigned cost. <em>They must be in a
   /// cost-ascending order.</em>
@@ -274,6 +274,6 @@
   ///
   /// \retval out Here we also have a choice.
-  /// - It can be a writable arc/edge map with \c bool value type. After
-  /// running the algorithm it will contain the found minimum cost spanning
+  /// - It can be a writable \c bool arc/edge map. After running the
+  /// algorithm it will contain the found minimum cost spanning
   /// tree: the value of an arc/edge will be set to \c true if it belongs
   /// to the tree, otherwise it will be set to \c false. The value of
@@ -302,6 +302,6 @@
 
 #ifdef DOXYGEN
-  template <typename Graph, typename In, typename Out>
-  Value kruskal(const Graph& g, const In& in, Out& out)
+  template <class Graph, class In, class Out>
+  Value kruskal(GR const& g, const In& in, Out& out)
 #else
   template <class Graph, class In, class Out>
@@ -315,4 +315,6 @@
 
 
+
+
   template <class Graph, class In, class Out>
   inline typename _kruskal_bits::KruskalValueSelector<In>::Value
